//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://emule.sf.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// ServerWnd.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "ServerWnd.h"


// CServerWnd dialog

IMPLEMENT_DYNAMIC(CServerWnd, CDialog)
CServerWnd::CServerWnd(CWnd* pParent /*=NULL*/)
	: CDialog(CServerWnd::IDD, pParent) {
}

CServerWnd::~CServerWnd(){
}
BOOL CServerWnd::OnInitDialog(){
	CDialog::OnInitDialog();
	serverlistctrl.Init(theApp.serverlist);
	((CEdit*)GetDlgItem(IDC_SPORT))->SetLimitText(5);
	GetDlgItem(IDC_SPORT)->SetWindowText("4661");
	return true;
}

void CServerWnd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SERVLIST, serverlistctrl);
	DDX_Control(pDX, IDC_EDIT1, servermsgbox);
	DDX_Control(pDX, IDC_LOGBOX, logbox);
}


BEGIN_MESSAGE_MAP(CServerWnd, CDialog)
	ON_BN_CLICKED(IDC_ADDSERVER, OnBnClickedAddserver)
END_MESSAGE_MAP()


// CServerWnd message handlers

void CServerWnd::OnBnClickedAddserver(){
	int8 serverip[4];
	if ( ((CIPAddressCtrl*)GetDlgItem(IDC_IPADDRESS))->GetAddress(serverip[0],serverip[1],serverip[2],serverip[3]) != 4){
		MessageBox("Please enter a valid IP","Incomplete IP Address",64);
		return;
	}
	if (!GetDlgItem(IDC_SPORT)->GetWindowTextLength()){
		MessageBox("Please enter a serverport","Incomplete serverport",64);
		return;
	}
	char portstr[5];
	GetDlgItem(IDC_SPORT)->GetWindowText(portstr,5);
	CServer* toadd = new CServer(atoi(portstr),serverip);

	int32 namelen = GetDlgItem(IDC_SNAME)->GetWindowTextLength();
	if (namelen){
		char* servername = new char[namelen+2];
		GetDlgItem(IDC_SNAME)->GetWindowText(servername,namelen+1);
		toadd->SetListName(servername);
	}
	else{
		char* servername = new char[24];
		sprintf(servername,"Server %i.%i.%i.%i",serverip[0],serverip[1],serverip[2],serverip[3]);
		toadd->SetListName(servername);
	}
	serverlistctrl.AddServer(toadd,true);
}
